VCMD0028040200000000COMPONENT          
Node "rSimResource"
{
Name "保持按钮测试（带指示灯）-2"
Id 1
NodeClass 
{
Id 1
Feature "rPrimitiveConeFeature"
{
Name "Cone"

Visible 1
Material  "aluminium_brushed"

BottomRadius 
{
  Expression "50 {mm}"
}

TopRadius 
{
  Expression "45 {mm}"
}

Height 
{
  Expression "12"
}

StartSweep 
{
  Expression "0 {deg}"
}

EndSweep 
{
  Expression "360 {deg}"
}

Sections 
{
  Expression "360"
}

Caps 1
}
SimAttribute "rSimApplyMaterialAttribute"
{
Material  "yellow"

}
VCID "dc8b83df-d267-4732-99a7-6b02e80bec1e"
}
Functionality "rSimBoolSignal"
{
Id 1
Name "BooleanSignal"
Connections
{
"PythonScript"
}
AutomaticReset 1
}
Functionality "rSimKinController"
{
Id 2
Name "ServoController"
Joints
{
  JointInfo
  {
    Index 0
    DofObject "J1"
  }
}
DummyDofs
{
}
UseHeartbeat 0
HeartRate 0
UsePhysicalHeartbeat 0
RootNode "保持按钮测试（带指示灯）-2"
FlangeNode "Link_1"
}
Functionality "rPythonScript"
{
Id 3
Name "PythonScript"
Script "from vcScript import *
\n
\napp = getApplication()
\ncomp = getComponent()
\nsim = getSimulation()
\n
\nboolTrue = comp.getProperty('Button')
\nboolFalse = comp.getProperty('Button')
\nboolS = comp.findBehaviour('BooleanSignal')
\nservo =comp.findBehaviour('ServoController')
\n
\ngreen_color = app.findMaterial('green')
\nyellow_color = app.findMaterial('yellow')
\n
\nnode_1 = comp.findNode('Link_1') 
\nj = servo.getJoint(0)
\n
\ndef OnPress(jogInfo,cursor_action,arg_list):
\n  global j
\n  # The cursor_action argument is the type of mouse action that occurs in the jog area.
\n  if cursor_action == 0:
\n    print 'cursor_action == 0'
\n  if jogInfo.Name == 'GreenJogInfo' and j.CurrentValue == 0 and cursor_action ==1:
\n    OnBoolTrue(None)
\n    print 'cursor_action == 1'
\n  if jogInfo.Name == 'GreenJogInfo' and j.CurrentValue == 6 and cursor_action ==2:
\n    OnBoolFalse(None)
\n    print 'cursor_action == 2'
\n 
\ndef OnBoolTrue(arg):
\n  boolS.signal(True)
\n 
\ndef OnBoolFalse(arg):
\n  boolS.signal(False)
\n  
\ndef OnRun():
\n  global j
\n  triggerer = boolS
\n  while sim.IsRunning:
\n    triggerCondition(lambda: getTrigger()==triggerer)
\n    #boolTrue = True 
\n    if ( boolS.Value == True or boolTrue == True ) and j.CurrentValue == 0:
\n      servo.moveJoint(0,6)
\n      OnBoolTrue(None)
\n      #node_1.MaterialInheritance = VC_MATERIAL_FORCE_INHERIT
\n      #node_1.NodeMaterial = green_color
\n      node_1.Material = green_color
\n      delay(0.1)
\n    if boolS.Value == False and j.CurrentValue == 6:
\n      servo.moveJoint(0,0)
\n      #node_1.MaterialInheritance = VC_MATERIAL_FORCE_INHERIT
\n      #node_1.NodeMaterial = yellow_color
\n      node_1.Material = yellow_color
\n      delay(0.1)
\n      
\n    #you don't need this part:
\n    #triggerCondition(lambda: getTrigger()==triggerer)
\n    #pass
\n  
\nboolTrue.OnChanged = OnBoolTrue 
\nboolFalse.OnChanged = OnBoolFalse 
\ngreenInfo = comp.findBehaviour('GreenJogInfo')
\ngreenInfo.OnInteract = OnPress
\n
\n
\n
\n"
CompatibilityMode 0
}
Functionality "rSimInterface"
{
Id 4
Name "Conn_BooleanSignal_Beacon_HD #5_RedSignal"
Flags 16390
Section 
{
Fields
{
rSimSignalField
{
Name "Signal"
Signal "BooleanSignal"
}
}
}
Abstract 1
}
Functionality "rSimInterface"
{
Id 5
Name "Conn_BooleanSignal_Beacon_HD #6_GreenSignal"
Flags 16390
Section 
{
Fields
{
rSimSignalField
{
Name "Signal"
Signal "BooleanSignal"
}
}
}
Abstract 1
}
Functionality "rSimInterface"
{
Id 6
Name "Conn_BooleanSignal_Beacon_HD_GreenSignal"
Flags 16390
Section 
{
Fields
{
rSimSignalField
{
Name "Signal"
Signal "BooleanSignal"
}
}
}
Abstract 1
}
VCID dc8b83df-d267-4732-99a7-6b02e80bec1e
OriginalUri vcid:dc8b83df-d267-4732-99a7-6b02e80bec1e
Revision 4
Location 1 0 0 0 0 1 0 0 0 0 1 0 111.671649518 -63.3484337166 -2.27373675443e-13 1 
ActiveSimulationLevel detailed
BOMname  "NewComponent"

BOMdescription  ""

Category  ""

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rButton>"
  {
    Name "Button"
    Value 1
    Group 10
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      TRANSLATE_USING_GETTEXT
    }
  }
}
Node "rSimLink"
{
Name "Link_1"
Id 2
NodeClass 
{
Id 2
Feature "rPrimitiveConeFeature"
{
Name "Cone_1"

Matrix 1 0 0 0 0 1 0 0 0 0 1 0 0 0 12 1 
Visible 1
BottomRadius 
{
  Expression "42"
}

TopRadius 
{
  Expression "40"
}

Height 
{
  Expression "8"
}

StartSweep 
{
  Expression "0 {deg}"
}

EndSweep 
{
  Expression "360 {deg}"
}

Sections 
{
  Expression "360"
}

Caps 1
}
}
Functionality "rJogInfo"
{
Id 7
Name "GreenJogInfo"
Dof "RZ"
Message "Drag Mouse To Jog Axis"
}
Dof  "Translational"
{
  Name "J1"
  Properties
  {
    Variable "rTExpressionVariable<rDouble>"
    {
      Name "SoftMinLimit"
      Value
      {
        Expression ""
      }
      Group 33
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
      }
    }
    Variable "rTExpressionVariable<rDouble>"
    {
      Name "SoftMaxLimit"
      Value
      {
        Expression ""
      }
      Group 34
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
      }
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxSpeed"
      Value 2000
      Group 35
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Speed" "ScalarQuantity"
      {
        Groups
        {
          UnitGroup "US Speed"
          {
            Unit
            {
              Name "feet per minute"
              Suffix "fpm"
              Factor 5.07999992370605
              Offset 0
            }
            Family "US degrees"
            Family "a"
          }
          UnitGroup "mm/min"
          {
            Unit
            {
              Name "dfdf"
              Suffix "m/min"
              Factor 1
              Offset 0
            }
          }
        }
      }
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxAcceleration"
      Value 5000
      Group 36
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Acceleration"
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "MaxDeceleration"
      Value 5000
      Group 37
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Acceleration"
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "LagTime"
      Value 0
      Group 41
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Time"
      Magnitude 1
    }
    Variable "rTVariable<rDouble>"
    {
      Name "SettleTime"
      Value 0
      Group 42
      Settings
      {
        VISIBLE
        EDITABLE_DISCONNECTED
        EDITABLE_CONNECTED
        EDITABLE_SIMULATING
        TRANSLATE_USING_GETTEXT
      }
      Quantity "Time"
      Magnitude 1
    }
  }
  JointValue 0
  MinLimit
  {
    Expression "0"
  }
  MaxLimit
  {
    Expression "6"
  }
  AxisType 6
  JointDeflection
  {
    Expression "VALUE"
  }
}
Offset 
{
  Expression ""
}
}
}
